#include <bits/stdc++.h>
#include "segment.h"

using namespace std;
const int MAXN = 3e6+10;
int n, a[MAXN];
int t[MAXN * 4];
int gcd(int a, int b)
{
    if(a < b)swap(a, b);
    while(b != 0)
    {
        int ost = a % b;
        a = b;
        b = ost;
    }
    return a;
}
void make_tree(int i, int l, int r)
{
    if(l == r)
    {
        t[i] = a[l];
        return;
    }
    int mid = (l + r)/2;
    make_tree(2*i, l, mid);
    make_tree(2*i+1, mid+1, r);
    t[i] = __gcd(t[2*i], t[2*i+1]);
}
int ql, qr;
int query(int i, int l, int r)
{
    if(qr < l || ql > r)return 0;
    if(ql <= l && r <= qr)return t[i];
    int mid = (l + r)/2;
    int val1 = query(2*i, l, mid);
    int val2 = query(2*i+1, mid+1, r);
    if(!val1)return val2;
    if(!val2)return val1;
    return __gcd(val1, val2);
}
int f[MAXN];
long long max_segment(std::vector<int> A)
{
    n = A.size();
    for (int i = 0; i < n; ++ i)
        a[i+1] = A[i];
    make_tree(1, 1, n);
    long long ans = 0;
    int val = 0;
    for (int i = 1; i <= n; ++ i)
    {
        long long currgcd, idx = i;
        val = 0;
        ql = i;
        qr = idx;
        currgcd = query(1, 1, n);

        int l = idx, r = n, mid, midgcd, lastid = idx;
        while(l <= r)
        {
            mid = (l + r)/2;
            ql = i;
            qr = mid;
            midgcd = query(1, 1, n);
            if(midgcd == currgcd)
            {
                l = mid + 1;
                lastid = mid;

            }
            else
            {
                r = mid - 1;
            }
        }
        f[i] = lastid+1;
    }
  //  for (int i = 1; i <= n; ++ i)
   //     cout << f[i] << " ";
   // cout << endl;
    int g;
    for (int i = 1; i <= n; ++ i)
    {
        int v = i;

        while(v <= n)
        {
            ql = i;
        qr = f[v]-1;
        g = query(1, 1, n);
        //cout << ql << " " << qr << " " << g << endl;
        ans = max(ans, 1LL * (qr - ql + 1) * g);
        v = f[v];
        }
    }
    return ans;
}
