#include <bits/stdc++.h>
#include "segment.h"

using namespace std;
const int MAXN = 3e6+10, MAXLOG = 25;
int n, a[MAXN];

int gcd(int a, int b)
{
    if(a < b)swap(a, b);
    while(b != 0)
    {
        int ost = a % b;
        a = b;
        b = ost;
    }
    return a;
}
int st[MAXN][MAXLOG];
void fill_st()
{
    for (int i = 1; i <= n; ++ i)
        st[i][0] = a[i];
    for (int j = 1; j <= 25; ++ j)
    {
        for (int i = 1; i <= n; ++ i)
        {
            if(i + (1 <<j) > n)continue;
            st[i][j] = gcd(st[i][j-1], st[i+(1 << j)][j-1]);
        }
    }
}
int query(int ql, int qr)
{
    int sz = qr - ql + 1;
    int logg =  log2(sz);
  //  cout << ql << " " << qr << " -> " << __gcd(st[ql][logg], st[qr - (1 << logg) + 1][logg]) << endl;
    return __gcd(st[ql][logg], st[qr - (1 << logg) + 1][logg]);
}
long long max_segment(std::vector<int> A)
{
   // cout << "eh" << endl;
    n = A.size();
    for (int i = 0; i < n; ++ i)
        a[i+1] = A[i];
    fill_st();
    long long ans = 0;
    int val = 0;
    int ql, qr;
    for (int i = 1; i <= n; ++ i)
    {

        long long currgcd, idx = i;
        val = 0;
        while(idx <= n)
        {
            val ++;
            ql = i;
            qr = idx;
            //cout << idx << endl;
            currgcd = query(ql, qr);

            int l = idx+1, r = n, mid, midgcd, lastid = idx;
            while(l <= r)
            {
                mid = (l + r)/2;
                ql = i;
                qr = mid;
                midgcd = query(ql, qr);
                if(midgcd == currgcd)
                {
                    l = mid + 1;
                    lastid = mid;

                }
                else
                {
                    r = mid - 1;

                }
            }
            ans = max(ans, 1LL * (lastid - i + 1) * currgcd);
            idx = lastid + 1;
            if(currgcd == 1)break;
        }

    }
    return ans;
}
