#include <bits/stdc++.h>
#include "segment.h"

using namespace std;
const long long MAXN = 3e6+10, MAXLOG = 22;
long long n, a[MAXN];

long long gcd(long long a, long long b)
{
    if(a < b)swap(a, b);
    while(b != 0)
    {
        long long ost = a % b;
        a = b;
        b = ost;
    }
    return a;
}
long long st[MAXN][MAXLOG];
void fill_st()
{
    for (long long i = 1; i <= n; ++ i)
        st[i][0] = a[i];
    for (long long j = 1; j <= 20; ++ j)
    {
        for (long long i = 1; i <= n; ++ i)
        {
            if(i + (1 <<j) - 1 > n)continue;
            st[i][j] = gcd(st[i][j-1], st[i+(1 << j)][j-1]);
        }
    }
}

long long query(long long ql, long long qr)
{ long long sz = qr - ql + 1;
    long long w = 1, step = 0;
    while(w*2 <= sz)
    {
        w *= 2;
        step ++;
    }

    long long logg =  step;
   if((1 << logg) == sz)
   {
      // cout << ql << " " << qr << " " << st[ql][logg] << endl;
       return st[ql][logg];
   }
  //cout << ql << " " << qr << " -> " << __gcd(st[ql][logg], st[qr - (1 << logg) + 1][logg]) << endl;
    return gcd(st[ql][logg], st[qr - w + 1][logg]);
}
long long max_segment(std::vector<int> A)
{
   // cout << "eh" << endl;
    n = A.size();
    for (long long i = 0; i < n; ++ i)
        a[i+1] = A[i];
    fill_st();
    long long ans = 0;
    long long val = 0;
    long long ql, qr;
    for (long long i = 1; i <= n; ++ i)
    {

        long long currgcd, idx = i;
        val = 0;
        while(idx <= n)
        {
            val ++;
            ql = i;
            qr = idx;
            //cout << idx << endl;
            currgcd = query(ql, qr);

            long long l = idx+1, r = n, mid, midgcd, lastid = idx;
            while(l <= r)
            {
                mid = (l + r)/2;
                ql = i;
                qr = mid;
                midgcd = query(ql, qr);
                if(midgcd == currgcd)
                {
                    l = mid + 1;
                    lastid = mid;

                }
                else
                {
                    r = mid - 1;

                }
            }
            ans = max(ans, 1LL * (lastid - i + 1) * currgcd);
            idx = lastid + 1;
            if(currgcd == 1)break;
        }

    }
    return ans;
}
