#include <bits/stdc++.h>
using namespace std;

const int maxpow = 40;
bool p[maxpow], used[maxpow];
int q, len;
long long n, k, st[maxpow], ans;

void init()
{
    len = 0;
    st[len] = 1;
    while (st[len] < n)
    {
        ++len;
        st[len] = st[len-1] * k;
    }
    ans = st[len];
    //cout << len << '\n' ;
}

void check()
{
    int i;
    long long v = 0;
    for (i=0; i<len; ++i)
    {
        if (p[i])
            v += st[i];
    }

    if (v >= n && v < ans)
        ans = v;
}

void solve(int pos)
{
    if (pos >= len)
    {
        check();
        return;
    }
    p[pos] = true;
    solve(pos+1);
    p[pos] = false;
    solve(pos+1);
}
long long solve2(long long num)
{
     for (int i=len; i>=0; --i)
     {
          if (num >= st[i] && !used[i])
          {
               used[i] = true;
               return st[i] + solve2(num-st[i]);
          }
     }
     return (long long)(0);
}

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> q ;
    while (q)
    {
        cin >> n >> k ;
        init();
        if (ans == n) cout << n << '\n' ;
        else
        {
            if (k == 2)
            {
                long long res = solve2(n);
                if (res == n) cout << n << '\n' ;
                else
                {
                    for (int i=0; i<=len; ++i)
                    {
                        if (!used[i])
                        {
                            res += st[i];
                            break;
                        }
                    }
                    if (res >= n && res < ans)
                        ans = res;
                    cout << ans << '\n' ;
                }
            }
            else
            {
               solve(0);
               cout << ans << '\n' ;
            }
        }
        -- q;
    }
}

int main()
{
    read();
    return 0;
}