#include <bits/stdc++.h>
using namespace std;

const int maxn = 128;
int n, k, a[maxn], br[maxn];
long long ans = LLONG_MAX, cur;
bool tree[maxn], used[maxn];
vector <pair<int, int>> v[maxn];

void read()
{
     ios_base::sync_with_stdio(false);
     cin.tie(NULL);
     cout.tie(NULL);

     cin >> n >> k ;
     int i, ver, d;
     for (i=1; i<=n; ++i)
     {
          cin >> a[i] >> ver >> d ;
          v[ver].push_back({i,d});
     }
}

void dfs(int ver)
{
     used[ver] = true;
     int i, len = (int)(v[ver].size()), nb;
     for (i=0; i<len; ++i)
     {
          nb = v[ver][i].first;
          if (!used[nb])
          {
               dfs(nb);
               br[nb] += a[nb];
               if (tree[nb])
                    br[nb] = 0;

               br[ver] += br[nb];
               cur += (br[nb] * v[ver][i].second);
          }
     }
}

void solve(int pos, int cnt1, int cnt0)
{
     if (pos > n)
     {
          cur = 0;
          for (int i=0; i<=n; ++i)
               used[i] = false;
          dfs(0);
          if (cur < ans)
               ans = cur;
          return;
     }

     if (cnt1 < k)
     {
          tree[pos] = true;
          solve(pos+1, cnt1+1, cnt0);
     }
     if (cnt0 < n-k)
     {
          tree[pos] = false;
          solve(pos+1, cnt1, cnt0+1);
     }
}

int main()
{
    read();
    tree[0] = true;
    solve(1, 0, 0);
    cout << ans << '\n' ;
    return 0;
}