#include <bits/stdc++.h>
#include "segment.h"
using namespace std;

const int maxn = 3e6+2, maxpow = 33;
int n, t[4*maxn], st[maxn];
long long a[maxn];
vector <int> v[maxpow];

void make_tree(int i, int l, int r)
{
     if (l == r)
     {
          t[i] = st[r];
          return;
     }
     int mid = (l+r) >> 1;
     make_tree(2*i, l, mid);
     make_tree(2*i+1, mid+1, r);
     t[i] = min(t[2*i], t[2*i+1]);
}

int query(int i, int l, int r, int&ql, int&qr)
{
     if (l > qr || r < ql) return INT_MAX;
     if (l >= ql && r <= qr) return t[i];
     int mid = (l+r) >> 1;
     return min(query(2*i, l, mid, ql, qr), query(2*i+1, mid+1, r, ql, qr));
}

int pow2(int num)
{
     int res = 0;
     while (num != 1)
     {
          num /= 2;
          ++ res;
     }
     return res;
}

long long max_segment(std::vector<int> A)
{
     int n = (int)(A.size()), i, minst = 33, maxst = -1;
     for (i=0; i<n; ++i)
     {
          a[i+1] = (long long)(A[i]);
          st[i+1] = pow2(a[i+1]);
          v[st[i+1]].push_back(i+1);
          if (st[i+1] > maxst)
               maxst = st[i+1];
          if (st[i+1] < minst)
               minst = st[i+1];
          //cout << a[i+1] << " " << st[i+1] << '\n' ;
     }
     make_tree(1, 1, n);
     //cout << minst << " " << maxst << '\n' ;

     int j, len, pr, ql, qr;
     map <int, bool> m;
     map <int, bool> :: iterator it;
     pair <int, bool> p;
     long long ans = (long long)(1 << minst) * n, cur;
     for (i=minst; i<maxst; ++i)
     {
          len = (int)(v[i].size());
          if (!len) continue;
          for (j=0; j<len; ++j)
               m[v[i][j]] = true;

          pr = 0;
          for (it=m.begin(); it!=m.end(); ++it)
          {
               p = (*it);
               ql = pr+1, qr = p.first-1;
               cur = (long long)(1 << query(1, 1, n, ql, qr)) * (long long)(qr - pr);
               if (cur > ans)
                    ans = cur;

               pr = qr+1;
          }
     }
     return ans;
}